<?php
add_action('ampmyr_post_template_header', 'AddHeader');

function AddHeader() {
    ?>
    <!doctype html>
    <html amp>
        <head>
            <meta charset="utf-8">
            <script async src="https://cdn.ampproject.org/v0.js"></script>
            <script async custom-element="amp-sidebar" src="https://cdn.ampproject.org/v0/amp-sidebar-0.1.js"></script>
            <?php do_action('ampmyr_extra_scripts'); ?>
            <?php do_action('ampmyr_title_tag'); ?>
            <?php do_action('ampmyr_metatags_yoast'); ?>
            <?php
            global $wp;
            $current_archive_url = home_url($wp->request);
            $amp_url = trailingslashit($current_archive_url);
            $remove = '/' . AMP_QUERY_VAR;
            $amp_url = str_replace($remove, '', $amp_url);
            ?>
            <link rel="canonical" href="<?php echo $amp_url; ?>">
            <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css">
            <meta name="viewport" content="width=device-width,minimum-scale=1">
            <?php require AMPMYR_PLUGIN_DIR . 'includes/design/style.php'; ?>
            <style amp-custom>
    <?php do_action('ampmyr_post_template_css'); ?>
            </style>
            <style amp-boilerplate>body{-webkit-animation:-amp-start 8s steps(1,end) 0s 1 normal both;-moz-animation:-amp-start 8s steps(1,end) 0s 1 normal both;-ms-animation:-amp-start 8s steps(1,end) 0s 1 normal both;animation:-amp-start 8s steps(1,end) 0s 1 normal both}@-webkit-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@-moz-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@-ms-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@-o-keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}@keyframes -amp-start{from{visibility:hidden}to{visibility:visible}}</style><noscript><style amp-boilerplate>body{-webkit-animation:none;-moz-animation:none;-ms-animation:none;animation:none}</style></noscript>
        </head>
        <body>
        <amp-sidebar id="sidebar" layout="nodisplay" side="right">
            <a href="#" class="amp-close-button" on="tap:sidebar.close" role="button" tabindex="0">X</a>
            <?php
            $defaults = array(
                'theme_location' => "ampmyr-menu-header",
                'menu' => '',
                'container' => 'div',
                'container_class' => '',
                'container_id' => '',
                'menu_class' => 'apm-sidebar-menu',
                'menu_id' => '',
                'echo' => true,
                'fallback_cb' => 'wp_page_menu',
                'before' => '',
                'after' => '',
                'link_before' => '',
                'link_after' => '',
                'items_wrap' => '<ul id="%1$s" class="%2$s">%3$s</ul>',
                'depth' => 0,
                'walker' => ''
            );

            wp_nav_menu($defaults);
            ?>  
        </amp-sidebar>
        <?php
        $phone_hd = GetThemeOptionData('phone_heading');
        $phone_NM = GetThemeOptionData('phone1');
        $amp_header_btn_txtCheck = GetThemeOptionData('amp_header_btn_txt');
        $amp_header_btn_txt = empty($amp_header_btn_txtCheck) ? "Tap Here To Call Us" : $amp_header_btn_txtCheck;
        $amp_header_logo = str_replace(get_bloginfo('url'), "", GetThemeOptionData('amp_header_logo', 'media_logo'));
        $amp_logo_alt_text = GetThemeOptionData('amp_logo_alt_text', 'media_logo_alt_text');
        $amp_logo_height = GetThemeOptionData('amp_logo_height');
        $amp_logo_width = GetThemeOptionData('amp_logo_width');
        ?>
        <div class="header-phone">
            <p><?php echo $phone_hd; ?>: <b><?php echo $phone_NM; ?></b></p>
            <a class="call-us-button-header" rel="nofollow" href="tel:<?php echo $phone_NM; ?>"><?php echo $amp_header_btn_txt; ?></a>
        </div>
        <div class="logo-amp">
            <a href="<?php echo get_bloginfo('url'); ?>"><amp-img src="<?php echo $amp_header_logo; ?>" alt="<?php echo $amp_logo_alt_text; ?>" height="<?php echo $amp_logo_height; ?>" width="<?php echo $amp_logo_width; ?>"></amp-img></a>
        </div>
        <div class="menu-amp-header">
            <ul>
                <li><a href="<?php echo get_bloginfo('url') ?>">Home</a></li>
                <li><a href="<?php echo get_bloginfo('url') ?>/contact-us">Contact</a></li>
                <li><a href="#" on="tap:sidebar.open">More</a></li>
            </ul>
        </div>
    <?php } ?>