<?php

class AMPMYR_Templates {

    function __construct($P_ID) {
        error_reporting(0);
        $this->ID = $P_ID;
        $this->post = get_post($P_ID);
        $this->post_Type = get_post_type();
        add_action('ampmyr_title_tag', array($this, 'ampmyr_add_custom_title_tag'));
        add_action('ampmyr_metatags_yoast', array($this, 'GetYoastMetaDiscriptions'));
        add_action('ampmyr_extra_scripts', array($this, 'GetExtraScripts'));
        //echo "<pre>" . print_r($this->post , true) . "</pre>";
    }

    public function Load_Head() {
        require AMPMYR_PLUGIN_DIR . 'includes/design/head.php';
    }

    public function Load_Footer() {
        require AMPMYR_PLUGIN_DIR . 'includes/design/footer.php';
    }

    public function Load_Body() {
        if (is_home()) {
            echo "<div class='container-amp main-contant-wrap-amp'>";
            echo $this->FilterBody($this->post->post_content);
            echo "</div>";
        } elseif (is_page()) {
            if (is_page_template("page-templates/tpl-contact-us.php")) {
                echo "<div class='container-amp main-contant-wrap-amp'>";
                echo "<h1>" . $this->post->post_title . "</h1>";
                echo $this->ContactUsMap($this->post->post_content);
                echo "</div>";
            } elseif (is_page_template("page-templates/tpl-blog.php")) {
                echo "<div class='container-amp main-contant-wrap-amp'>";
                echo "<h1>" . $this->post->post_title . "</h1>";
                echo $this->GetBlogData();
                echo "<a class='amp-read-more-bloglink' href='" . GetThemeOptionData("amp_blog_readmore_link") . "'>Read more</a>";
                echo "</div>";
            } elseif (is_page_template("page-templates/tpl-testimonial.php")) {
                echo "<div class='container-amp main-contant-wrap-amp'>";
                echo "<h1>" . $this->post->post_title . "</h1>";
                echo $this->GetTestimonialData();
                echo "</div>";
            } elseif (is_page_template("page-templates/tpl-lawyer-endrosment.php")) {
                echo "<div class='container-amp main-contant-wrap-amp'>";
                echo "<h1>" . $this->post->post_title . "</h1>";
                echo $this->GetTestimonialData(TRUE);
                echo "</div>";
            } else {
                echo "<div class='container-amp main-contant-wrap-amp'>";
                echo "<h1>" . $this->post->post_title . "</h1>";
                echo $this->FilterBody($this->post->post_content);
                echo "</div>";
            }
        } elseif (is_single()) {
            if ($this->post_Type == "attorneyprofile") {
                $Feature_img = wp_get_attachment_url(get_post_thumbnail_id($this->ID));
                echo "<div class='container-amp main-contant-wrap-amp'>";
                echo "<h1 class='text-center'>" . $this->post->post_title . "</h1>";
                echo "<div class='attorney-profile-amp-img'><amp-img src='" . $Feature_img . "' width='360' height='248' layout='responsive'/></div>";
                echo $this->FilterBody($this->post->post_content);
                echo $this->GetAttorneyProfileTabs();
                echo "</div>";
            } elseif ($this->post_Type == "attachment") {
                echo "<div class='container-amp main-contant-wrap-amp'>";
                echo "<h1 class='text-center'>" . $this->post->post_title . "</h1>";
                echo "</div>";
            } else {
                echo "<div class='container-amp main-contant-wrap-amp'>";
                echo "<h1>" . $this->post->post_title . "</h1>";
                echo $this->FilterBody($this->post->post_content);
                echo "</div>";
            }
        } elseif (is_category()) {
            echo "<div class='container-amp main-contant-wrap-amp'>";
            echo "<h1>";
            printf(__('Category: %s', 'twentyfourteen'), single_cat_title('', false));
            echo "</h1>";
            echo "<hr />";
            echo $this->GetCategoryData();
            echo "</div>";
        } elseif (is_tag()) {
            echo "<div class='container-amp main-contant-wrap-amp'>";
            echo "<h1>";
            printf(__('Category: %s', 'twentyfourteen'), single_cat_title('', false));
            echo "</h1>";
            echo "<hr />";
            echo $this->GetTagData();
            echo "</div>";
        } else {
            echo "No";
        }
    }

    public function FilterBody($Html) {
        $Html = $this->CheckHtmlContentAMPMetaBox($Html);
        $Data = $this->RemoveAllShortcode($Html);
        $Data = $this->RemoveunwantedTagsFromContent($Data);
        $Data = $this->ConvertTagInToAmpTag($Data);
        $Data = $this->RemoveInlineCssStyles($Data);
        return apply_filters('the_content', $Data);
    }

    public function RemoveAllShortcode($content) {
        global $shortcode_tags;
        if (!AMPMYR::ampmyr_is_amp_endpoint() || empty($shortcode_tags) || !is_array($shortcode_tags)) {
            return $content;
        }
        $regex = get_shortcode_regex();
        $regex = str_replace("number|", "", $regex);
        $content = preg_replace("/$regex/", '', $content);
        return $content;
    }

    public function RemoveunwantedTagsFromContent($content) {
        $content = preg_replace('/property=[^>]*/', '', $content);
        $content = preg_replace('/vocab=[^>]*/', '', $content);
        //  $content = preg_replace('/type=[^>]*/', '', $content);
        $content = preg_replace('/value=[^>]*/', '', $content);
        //  $content = preg_replace('/date=[^>]*/', '', $content);
        $content = preg_replace('/noshade=[^>]*/', '', $content);
        $content = preg_replace('/contenteditable=[^>]*/', '', $content);
        //  $content = preg_replace('/time=[^>]*/', '', $content);
        $content = preg_replace('/non-refundable=[^>]*/', '', $content);
        $content = preg_replace('/security=[^>]*/', '', $content);
        $content = preg_replace('/deposit=[^>]*/', '', $content);
        $content = preg_replace('/for=[^>]*/', '', $content);
        $content = preg_replace('/nowrap="nowrap"/', '', $content);
        $content = preg_replace('#<comments-count.*?>(.*?)</comments-count>#i', '', $content);
        $content = preg_replace('#<time.*?>(.*?)</time>#i', '', $content);
        $content = preg_replace('#<badge.*?>(.*?)</badge>#i', '', $content);
        $content = preg_replace('#<plusone.*?>(.*?)</plusone>#i', '', $content);
        $content = preg_replace('#<col.*?>#i', '', $content);
        $content = preg_replace('#<table.*?>#i', '<table width="100%">', $content);
        /* Removed So Inline style can work
          $content = preg_replace('#<style scoped.*?>(.*?)</style>#i', '', $content); */
        $content = preg_replace('/href="javascript:void*/', ' ', $content);
        $content = preg_replace('/<script[^>]*>.*?<\/script>/i', '', $content);
        //for removing attributes within html tags
        $content = preg_replace('/(<[^>]+) onclick=".*?"/', '$1', $content);
        /* Removed So Inline style can work
          $content = preg_replace('/(<[^>]+) style=".*?"/', '$1', $content);
         */
        $content = preg_replace('/(<[^>]+) rel=".*?"/', '$1', $content);
        $content = preg_replace('/(<[^>]+) ref=".*?"/', '$1', $content);
        $content = preg_replace('/(<[^>]+) date=".*?"/', '$1', $content);
        $content = preg_replace('/(<[^>]+) time=".*?"/', '$1', $content);
        $content = preg_replace('/(<[^>]+) imap=".*?"/', '$1', $content);
        $content = preg_replace('/(<[^>]+) date/', '$1', $content);
        $content = preg_replace('/(<[^>]+) spellcheck/', '$1', $content);
        $content = preg_replace('/<font(.*?)>(.*?)<\/font>/', '$2', $content);

        //removing scripts and rel="nofollow" from Body and from divs
        //issue #268
        $content = str_replace(' rel="nofollow"', "", $content);
        $content = preg_replace('/<script[^>]*>.*?<\/script>/i', '', $content);
        /// simpy add more elements to simply strip tag but not the content as so
        /// Array ("p","font");
        $tags_to_strip = Array("thrive_headline", "type", "date", "time", "place", "state", "city");
        foreach ($tags_to_strip as $tag) {
            $content = preg_replace("/<\\/?" . $tag . "(.|\\s)*?>/", '', $content);
        }
        // regex on steroids from here on
        // issue #420
        $content = preg_replace("/<div\s(class=.*?)(href=((" . '"|' . "'" . ')(.*?)("|' . "'" . ')))\s(width=("|' . "'" . ')(.*?)("|' . "'" . "))>(.*)<\/div>/i", '<div $1>$11</div>', $content);
        $content = preg_replace('/<like\s(.*?)>(.*)<\/like>/i', '', $content);
        $content = preg_replace('/<g:plusone\s(.*?)>(.*)<\/g:plusone>/i', '', $content);
        $content = preg_replace('/imageanchor="1"/i', '', $content);
        $content = preg_replace('/<plusone\s(.*?)>(.*?)<\/plusone>/', '', $content);

        return $content;
    }

    public function ConvertTagInToAmpTag($Html) {
        $Html = $this->remove_width_and_height_attribute($Html);
        $Html = $this->AddImageWidthAndHeight($Html);
        if ($this->CheckYoutubeIframe($Html)) {
            $Html = $this->ConvertYoutubeIframeInAMPTag($Html);
        }
        $Html = str_ireplace(
                ['<img', '<video', '/video>', '<audio', '/audio>'], ['<amp-img', '<amp-video', '/amp-video>', '<amp-audio', '/amp-audio>'], $Html);
        # Add closing tags to amp-img custom element
        $Html = preg_replace('/<amp-img(.*?)>/', '<amp-img$1></amp-img>', $Html);
        # Whitelist of HTML tags allowed by AMP
        $Html = strip_tags($Html, '<h1><h2><h3><h4><h5><h6><a><p><ul><ol><li><blockquote><q><cite><ins><del><strong><em><code><pre><svg><table><thead><tbody><tfoot><th><tr><td><dl><dt><dd><article><section><header><footer><aside><figure><time><abbr><div><span><hr><small><br><amp-img><amp-audio><amp-video><amp-ad><amp-anim><amp-carousel><amp-fit-rext><amp-image-lightbox><amp-instagram><amp-lightbox><amp-twitter><amp-youtube><amp-iframe><b>');
        return $Html;
    }

    public function CheckYoutubeIframe($Html) {
        $YTbe_Iframes = preg_match_all("/<iframe[^>]*src=\"[^\"]*youtu[.]?be.*<\\/iframe>/mi", $Html, $matches);
        if ($YTbe_Iframes < 1) {
            return FALSE;
        } else {
            return TRUE;
        }
    }

    public function CheckAudioTag($Html) {
        $YTbe_Iframes = preg_match_all('#<audio[^>]+>.*?</audio>#is', $Html, $matches);
        if ($YTbe_Iframes < 1) {
            return FALSE;
        } else {
            return TRUE;
        }
    }

    public function ConvertYoutubeIframeInAMPTag($Html) {
        $dom = new DOMDocument();
        $dom->loadHTML('<?xml encoding="utf-8" ?>' . $Html);
        $iframes = $dom->getElementsByTagName('iframe');
        $i = $iframes->length - 1;
        while ($i > -1) {
            $iframe = $iframes->item($i);
            $YTube_Src = $iframe->getAttribute('src');
            $YTB_SA = explode("/", $YTube_Src);
            $YTB_IDS = end($YTB_SA);
            $YTB_ID_A = explode("?", $YTB_IDS, 2);
            $YTB_ID = $YTB_ID_A[0];

            $AMP_YTB = $dom->createElement('amp-youtube');
            $AMP_YTB->setAttribute('data-videoid', $YTB_ID);
            $AMP_YTB->setAttribute('layout', "responsive");
            $AMP_YTB->setAttribute('width', "480");
            $AMP_YTB->setAttribute('height', "270");

            $iframe->parentNode->replaceChild($AMP_YTB, $iframe);
            $i--;
        }
        return $dom->saveHTML();
    }

    public function remove_width_and_height_attribute($html) {
        return preg_replace('/(height|width)="\d*"\s/', "", $html);
    }

    public function AddImageWidthAndHeight($html) {
        $dom = new DOMDocument();
        $dom->loadHTML('<?xml encoding="utf-8" ?>' . $html);
        //Create new wrapper div
        $new_div = $dom->createElement('div');
        $new_div->setAttribute('class', 'wrapper-amp-img');

        foreach ($dom->getElementsByTagName('img') as $img) {
            $new_div_clone = $new_div->cloneNode();
            list($width, $height) = getimagesize($img->getAttribute('src'));
            $New_Src = str_replace(get_bloginfo('url'), "", $img->getAttribute('src'));
            $img->setAttribute('width', $width);
            $img->setAttribute('height', $height);
            $img->setAttribute('layout', "responsive");
            $img->setAttribute('src', $New_Src);
            $img->parentNode->replaceChild($new_div_clone, $img);
            $new_div_clone->appendChild($img);
        }
        $html = $dom->saveHTML();
        return $html;
    }

    public function RemoveInlineCssStyles($content) {
        $content = preg_replace('/(<[^>]*) style=("[^"]+"|\'[^\']+\')([^>]*>)/i', '$1$3', $content);
        return $content;
    }

    public function GetAttorneyProfileTabs() {
        $Tab1_heading = get_post_meta($this->ID, 'spk_attornet_profile_tab1_hd', 'true');
        $Tab2_heading = get_post_meta($this->ID, 'spk_attornet_profile_tab2_hd', 'true');
        $Tab1_Text = get_post_meta($this->ID, 'spk_attornet_profile_tab1_Text', 'true');
        $Tab2_Text = get_post_meta($this->ID, 'spk_attornet_profile_tab2_Text', 'true');
        $Tab1_More_Text = get_post_meta($this->ID, 'spk_attornet_profile_more1_text', 'true');
        $Tab2_More_Text = get_post_meta($this->ID, 'spk_attornet_profile_more2_text', 'true');
        $Tab1_More_Link = get_post_meta($this->ID, 'spk_attornet_profile_more1_link', 'true');
        $Tab2_More_Link = get_post_meta($this->ID, 'spk_attornet_profile_more2_link', 'true');
        $Tottal_Reviews = get_post_meta($this->ID, 'spk_attornet_profile_reviews', 'true');
        $Tottal_Endrosments = get_post_meta($this->ID, 'spk_attornet_profile_endorsements', 'true');
        $Hide_Tab1 = get_post_meta($this->ID, 'spk_attornet_profile_tab1_hide', 'true');
        $Hide_Tab2 = get_post_meta($this->ID, 'spk_attornet_profile_tab2_hide', 'true');
        /* ................................................................................ */
        $data = "";
        if (empty($Hide_Tab1)) {
            $data .= "<hr class='amp-sep-attorney-profile' />";
            $data .= "<h2>" . $Tab1_heading . "</h2>";
            $data .= "<div class='attorney-profile-amp-tab-wrap'>" . $this->FilterBody($Tab1_Text) . "</div>";
        }
        if (empty($Hide_Tab2)) {
            $data .= "<hr class='amp-sep-attorney-profile' />";
            $data .= "<h2>" . $Tab2_heading . "</h2>";
            $data .= "<div class='attorney-profile-amp-tab-wrap'>" . $this->FilterBody($Tab2_Text) . "</div>";
        }
        return $data;
    }

    public function ContactUsMap($Html) {
        $Html = $this->CheckHtmlContentAMPMetaBox($Html);
        $data = "";
        $data.= "<div class='contactus-amp-map-div'>";
        $data.= $Html;
        $data.= "</div>";
        return $this->FilterBody($data);
    }

    public function GetBlogData() {
        $data = "";
        $args = array(
            'post_type' => 'post',
            'posts_per_page' => "10",
            'post_status' => 'publish',
            'exclude' => GetThemeOptionData('exclude_categories'),
            'orderby' => 'date',
            'order' => 'DESC',
            'paged' => $paged
        );
        $wp_query = new WP_Query($args);
        while ($wp_query->have_posts()) : $wp_query->the_post();
            $Html = $this->CheckHtmlContentAMPMetaBox(get_the_content(), get_the_ID());
            $data .="<div class='amp-blog-wrap-inner'>";
            $data .="<a href='" . get_the_permalink() . "'><h3>" . get_the_title() . "</h3></a>";
            $data .= "<div class='amp-blog-short-content'>" . wp_trim_words($Html, 50, '...<a href="' . get_the_permalink() . '">Read more</a>') . "</div>";
            $data .="</div>";
        endwhile;
        return $this->FilterBody($data);
    }

    public function GetCategoryData() {
        $data = "";
        if (have_posts()) :
            while (have_posts()) : the_post();
                $Html = $this->CheckHtmlContentAMPMetaBox(get_the_content(), get_the_ID());
                $data .="<div class='amp-blog-wrap-inner'>";
                $data .="<a href='" . get_the_permalink() . "'><h3>" . get_the_title() . "</h3></a>";
                $data .= "<div class='amp-blog-short-content'>" . wp_trim_words($Html, 50, '...<a href="' . get_the_permalink() . '">Read more</a>') . "</div>";
                $data .="</div>";
            endwhile;
        endif;
        return $this->FilterBody($data);
    }

    public function GetTagData() {
        $data = "";
        if (have_posts()) :
            while (have_posts()) : the_post();
                $Html = $this->CheckHtmlContentAMPMetaBox(get_the_content(), get_the_ID());
                $data .="<div class='amp-blog-wrap-inner'>";
                $data .="<a href='" . get_the_permalink() . "'><h3>" . get_the_title() . "</h3></a>";
                $data .= "<div class='amp-blog-short-content'>" . wp_trim_words($Html, 50, '...<a href="' . get_the_permalink() . '">Read more</a>') . "</div>";
                $data .="</div>";
            endwhile;
        endif;
        return $this->FilterBody($data);
    }

    public function GetTestimonialData($type = FALSE) {
        if ($type) {
            $paged = ( get_query_var('paged') ) ? get_query_var('paged') : 1;
            $args = array(
                'post_type' => 'testimonial',
                'post_status' => 'publish',
                'orderby' => 'date',
                'order' => 'DESC',
                'posts_per_page' => 100,
                'paged' => $paged
            );
            $wp_query = new WP_Query($args);
            while ($wp_query->have_posts()) : $wp_query->the_post();
                if (has_tag("4", $post->ID)) {
                    $data .="<div class='amp-testimonial-wrap-inner'>";
                    $data .= get_the_content();
                    $data .="<div class='cl-name'><strong>" . get_the_title() . "</strong></div>";
                    $data .="</div>";
                    $data .="<hr />";
                }
            endwhile;
            return $this->FilterBody($data);
        } else {
            $paged = ( get_query_var('paged') ) ? get_query_var('paged') : 1;
            $args = array(
                'post_type' => 'testimonial',
                'post_status' => 'publish',
                'orderby' => 'date',
                'order' => 'DESC',
                'posts_per_page' => 100,
                'paged' => $paged
            );
            $wp_query = new WP_Query($args);
            while ($wp_query->have_posts()) : $wp_query->the_post();
                if (has_tag("3", $post->ID)) {
                    $data .="<div class='amp-testimonial-wrap-inner'>";
                    $data .= get_the_content();
                    $data .="<div class='cl-name'><strong>" . get_the_title() . "</strong></div>";
                    $data .="</div>";
                    $data .="<hr />";
                }
            endwhile;
            return $this->FilterBody($data);
        }
    }

    public function ampmyr_add_custom_title_tag() {
        $Title_Page_Yoast = get_post_meta($this->ID, '_yoast_wpseo_title', true);
        echo "<title>";
        if (!empty($Title_Page_Yoast)) {
            echo $Title_Page_Yoast;
        } else {
            // title for a single post and single page
            if (is_single() || is_page()) {
                global $post;
                $title = $post->post_title;
                echo $title . ' | ' . get_option('blogname');
            }
            // title for archive pages
            if (is_archive()) {
                echo strip_tags(get_the_archive_title(''));
                echo ' | ';
                echo strip_tags(get_the_archive_description(''));
            }

            $site_title = get_bloginfo('name') . ' | ' . get_option('blogdescription');
            if (is_home()) {
                global $wp;
                $current_archive_url = home_url($wp->request);
                $current_url_in_pieces = explode('/', $current_archive_url);
                $cnt = count($current_url_in_pieces);
                if (is_numeric($current_url_in_pieces[$cnt - 1])) {
                    $site_title .= ' | Page ' . $current_url_in_pieces[$cnt - 1];
                }
                echo $site_title;
            }

            if (is_search()) {
                echo "You searched for:" . '  ' . get_search_query();
            }
        }
        echo "</title>";
    }

    public function GetYoastMetaDiscriptions() {
        $yoast_meta = get_post_meta($this->ID, '_yoast_wpseo_metadesc', true);
        echo "<meta name='description' content='" . $this->string_sanitize($yoast_meta) . "'/>";
    }

    public function CheckHtmlContentAMPMetaBox($Html, $ID = FALSE) {
        if ($ID) {
            $ShowAmpContent = get_post_meta($ID, 'spk_amp_show_checkbox', 'true');
            $AmpContent = get_post_meta($ID, 'spk_amp_content_editor', 'true');
        } else {
            $ShowAmpContent = get_post_meta($this->ID, 'spk_amp_show_checkbox', 'true');
            $AmpContent = get_post_meta($this->ID, 'spk_amp_content_editor', 'true');
        }

        if ($ShowAmpContent) {
            return $AmpContent;
        } else {
            return $Html;
        }
    }

    public function string_sanitize($s) {
        $s = str_replace("'", '', $s);
        $s = str_replace('"', '', $s);
        $s = str_replace('/', '', $s);
        $s = str_replace('`', '', $s);
        $s = str_replace('~', '', $s);
        return $s;
    }

    public function GetExtraScripts() {
        $ContentPass = $this->CheckHtmlContentAMPMetaBox($this->post->post_content);
        $Check_YTB = $this->CheckYoutubeIframe($ContentPass);
        $Check_Audio = $this->CheckAudioTag($ContentPass);
        if ($Check_YTB) {
            echo '<script async custom-element="amp-youtube" src="https://cdn.ampproject.org/v0/amp-youtube-0.1.js"></script>';
        }
        if ($Check_Audio) {
            echo '<script async custom-element="amp-audio" src="https://cdn.ampproject.org/v0/amp-audio-0.1.js"></script>';
        }
    }

}
