/*
 * @package WordPress
 * @subpackage Xpert
 * @since Xpert 1.0
 * 
 * Define action for icons
 * 
 */

/* --------------Add Phone Number ----------------- */
(function () {
    tinymce.create('tinymce.plugins.number', {
        init: function (ed, url) {
            ed.addButton('number', {
                title: 'Add Phone Number',
                image: url + '/icons/add-number.png',
                onclick: function () {
                    ed.selection.setContent('[number type="1"]');
                }
            });
        },
        createControl: function (n, cm) {
            return null;
        },
    });
    tinymce.PluginManager.add('number', tinymce.plugins.number);
})();
/* --------------Add Video ----------------- */
(function () {
    tinymce.create('tinymce.plugins.videocode', {
        init: function (ed, url) {
            ed.addButton('videocode', {
                title: 'Add Video ',
                image: url + '/icons/add-video.png',
                onclick: function () {
                    jQuery('#add-video').modal({
                        onShow: function (dialog) {
                            jQuery("a", dialog.data).click(function (event) {
                                event.preventDefault();
                                type = jQuery("#video_type").attr('value');
                                video_id = jQuery("#video_id").attr('value');
                                auto_play = jQuery("#auto_play").attr('value');
                                video_width = jQuery("#video_width").attr('value');
                                video_height = jQuery("#video_height").attr('value');
                                if (video_id != '' && type != '') {
                                    ed.selection.setContent("[videocode type='" + type + "' id='" + video_id + "' width='" + video_width + "' height='" + video_height + "' autoplay='" + auto_play + "']");
                                }
                                jQuery.modal.close();
                                return false;
                            });
                        }
                    });


                }
            });
        },
        createControl: function (n, cm) {
            return null;
        },
    });
    tinymce.PluginManager.add('videocode', tinymce.plugins.videocode);
})();
/* --------------Add Category Page List Title ----------------- */
(function () {
    tinymce.create('tinymce.plugins.catlisthd', {
        init: function (ed, url) {
            ed.addButton('catlisthd', {
                title: 'Add Category Page Title ',
                image: url + '/icons/add-cat-hd.png',
                onclick: function () {
                    jQuery('#add-cat-title').modal({
                        onShow: function (dialog) {
                            jQuery("a", dialog.data).click(function (event) {
                                event.preventDefault();
                                catlist_hd = jQuery("#catlist_hd").attr('value');
                                catlist_link = jQuery("#catlist_link").attr('value');
                                if (catlist_link != '' && catlist_hd != '') {
                                    ed.selection.setContent('[catlisthd hd="' + catlist_hd + '" link="' + catlist_link + '"]');
                                }
                                jQuery.modal.close();
                                return false;
                            });
                        }
                    });


                }
            });
        },
        createControl: function (n, cm) {
            return null;
        },
    });
    tinymce.PluginManager.add('catlisthd', tinymce.plugins.catlisthd);
})();