<?php

add_action('init', 'add_editor_buttons');

function add_editor_buttons() {
    if (current_user_can('edit_posts') && current_user_can('edit_pages')) {
        add_filter('mce_external_plugins', 'add_admin_icon');
        add_filter('mce_buttons_3', 'addd_row3');
        wp_register_script('poupModal', get_template_directory_uri() . '/framework/js/jquery.simplemodal.js', 'jquery', '1.0', TRUE);
        wp_register_script('function.admin', get_template_directory_uri() . '/framework/js/function.admin.php', 'jquery', '1.0', TRUE);
        wp_enqueue_script('poupModal');
        wp_enqueue_script('function.admin');
        wp_enqueue_style('font-awesome', get_template_directory_uri() . '/css/font-awesome.css');
        wp_enqueue_style('modalstyle', get_template_directory_uri() . '/framework/css/modal.css');
    }
}

//add row 3 in editor
function addd_row3($buttons) {
    array_push($buttons, 'videocode', 'number', "catlisthd");
    return $buttons;
}

function add_admin_icon($plugin_array) {
    $icon_array['videocode'] = get_template_directory_uri() . '/framework/js/add-icons.js';
    $icon_array['number'] = get_template_directory_uri() . '/framework/js/add-icons.js';
    $icon_array['catlisthd'] = get_template_directory_uri() . '/framework/js/add-icons.js';
    return $icon_array;
}

/* ---------------Add Phone Number shortcodes-------------------- */

function phone_number($atts, $content = null) {
    global $data;
    extract(shortcode_atts(array(
        'type' => '1'
                    ), $atts));
    if ($type == '1') {
        $return = $data['phone1'];
    } elseif ($type == '2') {
        $return = $data['phone2'];
    }
    return $return;
}

add_shortcode('number', 'phone_number');

/* ---------------Add CAll To Action shortcodes-------------------- */

function CallToAction($atts) {
    global $data;
    $CallToAction_pic = $data['call-to-action-img'];
    $CallToAction_text = $data['call-to-action-text'];
    $CallToAction_AltText = $data['call-to-action-alt_text'];
    $return = "<div class='call_info'><img src='$CallToAction_pic' alt='$CallToAction_AltText' /></div>
               <div class='call_bio'><p>$CallToAction_text</p></div>";
    return $return;
}

add_shortcode('CTA', 'CallToAction');

/* ---------------Add catlisthd shortcodes-------------------- */

function CatListHd($atts) {
    $link = $atts['link'];
    $HD = $atts['hd'];
    $return = '<div class="cat-title-div"><a href="' . $link . '">' . $HD . '</a></div>';
    return $return;
}

add_shortcode('catlisthd', 'CatListHd');

/* ---------------Add Video Code shortcodes-------------------- */

function VideoCode($atts) {
    $type = $atts['type'];
    $Video_Id = $atts['id'];
    $Video_width = $atts['width'];
    $Video_height = $atts['height'];
    $Video_autoplay = $atts['autoplay'];

    if ($type == "youtube") {
        $return = '<iframe class="video-code-frame" width="' . $Video_width . '" height="' . $Video_height . '" align="middle" src="http://www.youtube.com/embed/' . $Video_Id . '?rel=0&autoplay=' . $Video_autoplay . '"></iframe>';
    } elseif ($type == "vimeo") {
        $return = '<iframe class="video-code-frame" width="' . $Video_width . '" height="' . $Video_height . '" align="middle" src="https://player.vimeo.com/video/' . $Video_Id . '?autoplay=' . $Video_autoplay . '"></iframe>';
    }

    return $return;
}

add_shortcode('videocode', 'VideoCode');
/* ------------EOF Shortcodes--------------- */
?>
