<?php
global $data;
require_once('framework/admin/index.php'); // To add custom Theme Options Framework
require_once('css/custom-css.php'); // To add custom Style
require_once('framework/shortcodes.php'); // To add custom Style
require_once('post-meta-box.php'); // To add custom Style
//require_once('script.php'); // To add custom Style
add_filter('widget_text', 'do_shortcode');
add_theme_support('html5', array('search-form'));

function spk_lawyer_setup() {
    // This theme uses wp_nav_menu() in one location.
    register_nav_menu('primary', __('Primary Menu', 'spk_lawyer'));
    register_nav_menu('secondary', __('Secondary Menu', 'spk_lawyer'));
    add_theme_support('post-thumbnails');
}

add_action('after_setup_theme', 'spk_lawyer_setup');

add_action('wp_enqueue_scripts', 'spk_lawyer_style');

function spk_lawyer_style() {
    wp_register_script('main_jquery', get_template_directory_uri() . '/js/jquery.js', array('jquery'), '2.5.1', TRUE);
    wp_register_script('spk-bootstrap', get_template_directory_uri() . '/js/bootstrap.js', array('jquery'), '2.5.1', TRUE);
    wp_register_script('spk-owl-carousel', get_template_directory_uri() . '/js/owl.carousel.js', array('jquery'), '2.5.1', TRUE);
    wp_register_script('spk-lawyer-funcations', get_template_directory_uri() . '/js/function.js', array('jquery'), '2.5.1', TRUE);

    //  wp_register_style('theme_css', get_template_directory_uri() . '/style.css', false, '1.0.0', 'all');
//    wp_register_style('queries-css', get_template_directory_uri() . '/css/queries.css', false, '1.0.0', 'all');

    wp_enqueue_script('main_jquery');
    wp_enqueue_script('spk-bootstrap');
    wp_enqueue_script('spk-owl-carousel');
    wp_enqueue_script('spk-lawyer-funcations');

    wp_enqueue_script('j_cookies', get_template_directory_uri() . '/js/jquery.cookie.js', array(), '1.5.1', TRUE);
    wp_enqueue_script('j_chat', get_template_directory_uri() . '/js/script2.js', array(), '1.5.1', TRUE);

    wp_enqueue_style('spk_bootstrap', get_template_directory_uri() . '/css/bootstrap.min.css', false, '3.1.0', 'all');
    wp_enqueue_style('spk_font_awesome', get_template_directory_uri() . '/css/font-awesome.min.css', false, '3.1.0', 'all');
    wp_enqueue_style('spk_owl_carousel', get_template_directory_uri() . '/css/owl.carousel.css', false, '3.1.0', 'all');
    wp_enqueue_style('spk_owl_theme', get_template_directory_uri() . '/css/owl.theme.css', false, '3.1.0', 'all');
    wp_enqueue_style('spk_hover', get_template_directory_uri() . '/css/hover.css', false, '3.1.0', 'all');
    wp_enqueue_style('spk_core', get_template_directory_uri() . '/css/core.css', false, '3.1.0', 'all');
    wp_enqueue_style('spk_tcore', get_template_directory_uri() . '/style.css', false, '1.1.0', 'all');
    wp_enqueue_style('queries-css', get_template_directory_uri() . '/css/queries.css', false, '1.0.0', 'all');
    wp_enqueue_style('gfonts', 'https://fonts.googleapis.com/css?family=Rajdhani:400,300,500,600,700|Droid+Serif:400,400italic,700,700italic|Open+Sans:400,300,300italic,400italic,600,600italic,700,700italic,800,800italic', false, '1.0.0', 'screen');
    wp_enqueue_style('chat-css', 'https://attorney-chat.com/design/defaulttheme/css/chat_opt.css', false, '1.0.0', 'all');
}

function spk_lawyer_wp_title($title, $sep) {
    global $paged, $page;

    if (is_feed())
        return $title;

// Add the site name.
    $title .= get_bloginfo('name', 'display');

// Add the site description for the home/front page.
    $site_description = get_bloginfo('description', 'display');
    if ($site_description && ( is_home() || is_front_page() ))
        $title = "$title $sep $site_description";

// Add a page number if necessary.
    if ($paged >= 2 || $page >= 2)
        $title = "$title $sep " . sprintf(__('Page %s', 'spk_lawyer'), max($paged, $page));

    return $title;
}

add_filter('wp_title', 'spk_lawyer_wp_title', 10, 2);

/**
 * Register sidebars.
 *
 * Registers our main widget area and the front page widget areas.
 *
 * @since Twenty Twelve 1.0
 */
function spk_lawyer_widgets_init() {
    register_sidebar(array(
        'name' => __('Blog Page Category Widget', 'spk_lawyer'),
        'id' => 'sidebar-1',
        'description' => __('', 'spk_lawyer'),
        'before_widget' => '<aside id="%1$s" class="widget-body %2$s animate-plus"  data-animation-delay="0.4s" data-animation-when-visible="true" data-animations="fadeInDown">',
        'after_widget' => '</aside>',
        'before_title' => '<h3 class="title-wegits">',
        'after_title' => '</h3>',
    ));
}

add_action('widgets_init', 'spk_lawyer_widgets_init');

if (!function_exists('spk_lawyer_content_nav')) :

    /**
     * Displays navigation to next/previous pages when applicable.
     *
     * @since Twenty Twelve 1.0
     */
    function spk_lawyer_content_nav($html_id) {
        global $wp_query;

        $html_id = esc_attr($html_id);

        if ($wp_query->max_num_pages > 1) :
            ?>
            <div class="blog_nav" id="<?php echo $html_id; ?>">
                <div class="nav-prev"><?php next_posts_link(__('<i class="fa fa-angle-left arrow_left"></i> <p>Previous Post</p>', 'spk_lawyer')); ?></div>            
                <div class="nav-next"><?php previous_posts_link(__('<i class="fa fa-angle-right arrow_right"></i> <p>Next Post</p>', 'spk_lawyer')); ?></div>
            </div>
            <?php
        endif;
    }

endif;
/* ...........Remove Comments...................... */

// Disable support for comments and trackbacks in post types
function df_disable_comments_post_types_support() {
    $post_types = get_post_types();
    foreach ($post_types as $post_type) {
        if (post_type_supports($post_type, 'comments')) {
            remove_post_type_support($post_type, 'comments');
            remove_post_type_support($post_type, 'trackbacks');
        }
    }
}

add_action('admin_init', 'df_disable_comments_post_types_support');

// Close comments on the front-end
function df_disable_comments_status() {
    return false;
}

add_filter('comments_open', 'df_disable_comments_status', 20, 2);
add_filter('pings_open', 'df_disable_comments_status', 20, 2);

// Hide existing comments
function df_disable_comments_hide_existing_comments($comments) {
    $comments = array();
    return $comments;
}

add_filter('comments_array', 'df_disable_comments_hide_existing_comments', 10, 2);

// Remove comments page in menu
function df_disable_comments_admin_menu() {
    remove_menu_page('edit-comments.php');
}

add_action('admin_menu', 'df_disable_comments_admin_menu');

// Redirect any user trying to access comments page
function df_disable_comments_admin_menu_redirect() {
    global $pagenow;
    if ($pagenow === 'edit-comments.php') {
        wp_redirect(admin_url());
        exit;
    }
}

add_action('admin_init', 'df_disable_comments_admin_menu_redirect');

// Remove comments metabox from dashboard
function df_disable_comments_dashboard() {
    remove_meta_box('dashboard_recent_comments', 'dashboard', 'normal');
}

add_action('admin_init', 'df_disable_comments_dashboard');

// Remove comments links from admin bar
function df_disable_comments_admin_bar() {
    if (is_admin_bar_showing()) {
        remove_action('admin_bar_menu', 'wp_admin_bar_comments_menu', 60);
    }
}

add_action('init', 'df_disable_comments_admin_bar');

/* Custom Excerpt Length */

function excerpt_length($length) {
    global $data;
    return "100";
}

add_filter('excerpt_length', 'excerpt_length');

function excerpt_more($more) {
    global $post;
    return '… <a href="' . get_permalink($post->ID) . '" class="blog-link">' . '' . __('Read More', 'law-firm') . '</a>';
}

add_filter('excerpt_more', 'excerpt_more');

function formatPhone($num) {
    $num = preg_replace('/[^0-9]/', '', $num);
    $len = strlen($num);

    if ($len == 10) {
        $num = preg_replace('/([0-9]{3})([0-9]{3})([0-9]{4})/', '($1)  $2 - $3 ', $num);
        return $num;
    } else {
        return '0';
    }
}

/* ....................................Clients Testimonial Post type............................ */

add_action('init', 'spk_testimonial_custom_post');

function spk_testimonial_custom_post() {
    global $data;
    register_post_type(
            'testimonial', array(
        'labels' => array(
            'name' => 'Testimonial',
            'singular_name' => 'testimonial'
        ),
        'public' => true,
        'show_ui' => true,
        'capability_type' => 'post',
        'hierarchical' => false,
        'rewrite' => array('slug' => $data['testi_slug']),
        'supports' => array('title', 'editor'),
        'taxonomies' => array('post_tag'),
        'can_export' => true,
        'menu_icon' => get_template_directory_uri() . '/images/testi-icon.png',
            )
    );
}

if (!function_exists('spk_post_nav')) :

    function spk_post_nav() {
        // Don't print empty markup if there's nowhere to navigate.
        $previous = ( is_attachment() ) ? get_post(get_post()->post_parent) : get_adjacent_post(false, '', true);
        $next = get_adjacent_post(false, '', false);

        if (!$next && !$previous) {
            return;
        }
        ?>
        <nav class="blog_nav" role="navigation">
            <?php
            previous_post_link('<div class="nav-prev">%link', __('<i class="fa fa-angle-left arrow_left"></i> <p>Previous Post</p></div>', 'twentyfourteen'));
            next_post_link('<div class="nav-next">%link', __('<i class="fa fa-angle-right arrow_right"></i> <p>Next Post</p></div>', 'twentyfourteen'));
            ?>
        </nav><!-- .navigation -->
        <?php
    }

endif;
/* ............................................................ */

function catch_that_image() {
    global $post, $posts;
    $first_img = '';
    ob_start();
    ob_end_clean();
    $output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
    $first_img = $matches[1][0];

    if (empty($first_img)) {
        return FALSE;
    }
    return $first_img;
}

/* ..............................Add Attorney profile  Post type.......................... */
add_action('init', 'spk_attorney_profile_custom_post');

function spk_attorney_profile_custom_post() {
    global $data;
    register_post_type(
            'attorneyprofile', array(
        'labels' => array(
            'name' => 'Attorney Profile',
            'singular_name' => 'attorney-profiles'
        ),
        'public' => true,
        'show_ui' => true,
        'capability_type' => 'page',
        'hierarchical' => false,
        'rewrite' => array('slug' => "attorney-profile"),
        'supports' => array('title', 'editor', "thumbnail"),
        'taxonomies' => array('post_tag'),
        'can_export' => true,
        'menu_icon' => get_template_directory_uri() . '/images/attorney-profile.png',
            )
    );
}
function get_cYear($atts) {
    $return = date('Y');
    return $return;
}
add_shortcode('current_y', 'get_cYear');
