<?php

add_filter('rwmb_meta_boxes', 'spk_register_meta_boxes');

/**
 * Register meta boxes
 *
 * @return void
 */
function spk_register_meta_boxes($meta_boxes) {
    /**
     * Prefix of meta keys (optional)
     * Use underscore (_) at the beginning to make keys hidden
     * Alt.: You also can make prefix empty to disable it
     */
// Better has an underscore as last sign
    $prefix = 'spk_';

    $meta_boxes[] = array(
// Meta box id, UNIQUE per meta box. Optional since 4.1.5
        'id' => 'standard',
// Meta box title - Will appear at the drag and drop handle bar. Required.
        'title' => __('Used These Meta Boxes For Related Topics and No johnson box', 'rwmb'),
// Post types, accept custom post types as well - DEFAULT is array('post'). Optional.
        'pages' => array('post', 'page'),
// Where the meta box appear: normal (default), advanced, side. Optional.
        'context' => 'normal',
// Order of meta box: high (default), low. Optional.
        'priority' => 'high',
// Auto save: true, false (default). Optional.
        'autosave' => true,
// List of meta fields
        'fields' => array(
            array(
                // Field name - Will be used as label
                'name' => __('Related Topics', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}related_topics",
// Field description (optional)
                'desc' => __('Enter Related Topics Manually', 'rwmb'),
                'type' => 'textarea',
// Default value (optional)
                'std' => __('', 'rwmb'),
// CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('No johnson Box', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}no_johnson_box",
// Field description (optional)
                'desc' => __('Check if You don\'t want to show johnson Box', 'rwmb'),
                'type' => 'checkbox',
// Default value (optional)
                'std' => __('', 'rwmb'),
// CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                'name' => __('Show Amp Content', 'rwmb'),
                'id' => "{$prefix}amp_show_checkbox",
                'desc' => __('Check if you want to show bottom editor content', 'rwmb'),
                'type' => 'checkbox',
                'std' => __('', 'rwmb'),
                'clone' => FALSE,
            ),
            array(
                'name' => __('AMP Content Editor', 'rwmb'),
                'id' => "{$prefix}amp_content_editor",
                'desc' => __('Enter Content', 'rwmb'),
                'type' => 'WYSIWYG',
                'std' => __('', 'rwmb'),
                'clone' => FALSE,
            )
        )
    );
// 1st meta box
    $meta_boxes[] = array(
// Meta box id, UNIQUE per meta box. Optional since 4.1.5
        'id' => 'standard',
// Meta box title - Will appear at the drag and drop handle bar. Required.
        'title' => __('Used These Meta Boxes For Attorney Profile', 'rwmb'),
// Post types, accept custom post types as well - DEFAULT is array('post'). Optional.
        'pages' => array('attorneyprofile'),
// Where the meta box appear: normal (default), advanced, side. Optional.
        'context' => 'normal',
// Order of meta box: high (default), low. Optional.
        'priority' => 'high',
// Auto save: true, false (default). Optional.
        'autosave' => true,
// List of meta fields
        'fields' => array(
            array(
                // Field name - Will be used as label
                'name' => __('Tab 1 Hide', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_tab1_hide",
                // Field description (optional)
                'desc' => __('Check if you Want to Hide Tab 1', 'rwmb'),
                'type' => 'checkbox',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Tab 1 Heading', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_tab1_hd",
                // Field description (optional)
                'desc' => __('Enter Tab1 Heading', 'rwmb'),
                'type' => 'Text',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Tab 1 Text', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_tab1_Text",
                // Field description (optional)
                'desc' => __('Enter Tab1 Text', 'rwmb'),
                'type' => 'wysiwyg',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Tab1 More Link', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_more1_link",
                // Field description (optional)
                'desc' => __('Enter More Link Link', 'rwmb'),
                'type' => 'Text',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Tab1 More Link Text', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_more1_text",
                // Field description (optional)
                'desc' => __('Enter More Link Text', 'rwmb'),
                'type' => 'Text',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "",
                // Field description (optional)
                'desc' => __('', 'rwmb'),
                'type' => 'divider',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Tab 2 Hide', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_tab2_hide",
                // Field description (optional)
                'desc' => __('Check if you Want to Hide Tab 2', 'rwmb'),
                'type' => 'checkbox',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Tab 2 Heading', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_tab2_hd",
                // Field description (optional)
                'desc' => __('Enter Tab2 Heading', 'rwmb'),
                'type' => 'Text',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Tab 2 Text', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_tab2_Text",
                // Field description (optional)
                'desc' => __('Enter Tab2 Text', 'rwmb'),
                'type' => 'wysiwyg',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Tab2 More Link', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_more2_link",
                // Field description (optional)
                'desc' => __('Enter More Link Link', 'rwmb'),
                'type' => 'Text',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Tab2 More Link Text', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_more2_text",
                // Field description (optional)
                'desc' => __('Enter More Link Text', 'rwmb'),
                'type' => 'Text',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "",
                // Field description (optional)
                'desc' => __('', 'rwmb'),
                'type' => 'divider',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Insert Total Number of Reviews', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_reviews",
                // Field description (optional)
                'desc' => __('Enter Total Number of Reviews', 'rwmb'),
                'type' => 'Text',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Insert Total Number of Endorsements', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}attornet_profile_endorsements",
                // Field description (optional)
                'desc' => __('Enter Total Number of Endorsements', 'rwmb'),
                'type' => 'Text',
                // Default value (optional)
                'std' => __('', 'rwmb'),
                // CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
        )
    );

    // 1st meta box
    $meta_boxes[] = array(
// Meta box id, UNIQUE per meta box. Optional since 4.1.5
        'id' => 'standard',
// Meta box title - Will appear at the drag and drop handle bar. Required.
        'title' => __('Used These Meta Boxes For Testimonial', 'rwmb'),
// Post types, accept custom post types as well - DEFAULT is array('post'). Optional.
        'pages' => array('testimonial'),
// Where the meta box appear: normal (default), advanced, side. Optional.
        'context' => 'normal',
// Order of meta box: high (default), low. Optional.
        'priority' => 'high',
// Auto save: true, false (default). Optional.
        'autosave' => true,
// List of meta fields
        'fields' => array(
            array(
                // Field name - Will be used as label
                'name' => __('Show Testiominial On home Page', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}testi_home",
// Field description (optional)
                'desc' => __('Check if you want to show Testimonial on Home Page', 'rwmb'),
                'type' => 'checkbox',
// Default value (optional)
                'std' => __('', 'rwmb'),
// CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
            array(
                // Field name - Will be used as label
                'name' => __('Home Testiominial Text', 'rwmb'),
                // Field ID, i.e. the meta key
                'id' => "{$prefix}testi_home_text",
// Field description (optional)
                'desc' => __('Insert Text Home Page Testimonial', 'rwmb'),
                'type' => 'wysiwyg',
// Default value (optional)
                'std' => __('', 'rwmb'),
// CLONES: Add to make the field cloneable (i.e. have multiple value)
                'clone' => FALSE,
            ),
        )
    );
    return $meta_boxes;
}
